#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "numbers"

const int LogN = 10, MidN = 1 << LogN, MaxN = MidN * MidN, AndN = MidN - 1;

int b [MidN];
int a [MaxN];
int n;

int main (void)
{
 int i, j, k, l, m, sum;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  memset (a, 0, sizeof (a));
  memset (b, 0, sizeof (b));
  for (m = 0; m < k; m++)
  {
   scanf (" %d", &l);
   if (l == 0)
   {
    scanf (" %d %d", &i, &j);
    sum = 0;
    for (; i <= j && (i & AndN); i++)
     sum += a[i];
    for (; i <= j && ((j + 1) & AndN); j--)
     sum += a[j];
    for (i >>= LogN, j >>= LogN; i <= j; i++)
     sum += b[i];
    printf ("%d\n", sum);
   }
   else
   {
    a[l]++;
    b[l >> LogN]++;
   }
  }
 }
 return 0;
}
