#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "parts"
typedef long long int64;

const int MaxN = 10, MaxL = (MaxN * (MaxN - 1)) >> 1,
 MaxK = ((MaxL * (MaxL - 1)) >> 1) + 1;

int64 p0 [MaxK], p1 [MaxK], p2 [MaxK];
bool r [MaxK];
int64 a [MaxL], b [MaxL], c [MaxL];
int x [MaxN], y [MaxN];
int k, l, n;

int main (void)
{
 int i, j, m, q;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  for (i = 0; i < n - 2; i++)
   for (j = i + 1; j < n - 1; j++)
    for (m = j + 1; m < n; m++)
     if ((x[i] - x[j]) * (y[m] - y[j]) == (x[m] - x[j]) * (y[i] - y[j]))
      assert (false);
  l = 0;
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
   {
    a[l] = y[i] - y[j];
    b[l] = x[j] - x[i];
    c[l] = -(x[i] * a[l] + y[i] * b[l]);
    l++;
   }
  k = 0;
/*
  p0[k] = 0;
  p1[k] = 1;
  p2[k] = 1;
  k++;
*/
  for (i = 0; i < l - 1; i++)
   for (j = i + 1; j < l; j++)
   {
    p0[k] = a[i] * b[j] - a[j] * b[i];
    p1[k] = b[i] * c[j] - b[j] * c[i];
    p2[k] = c[i] * a[j] - c[j] * a[i];
    k++;
   }
  memset (r, 1, sizeof (r));
  for (i = 0; i < k - 1; i++)
   for (j = i + 1; j < k; j++)
    if (p0[i] * p1[j] == p0[j] * p1[i] && p0[i] * p2[j] == p0[j] * p2[i])
     r[j] = false;
  m = 0;
  for (i = 0; i < k; i++)
   m += r[i];
  q = l;
  for (i = 0; i < l; i++)
   for (j = 0; j < k; j++) if (r[j])
    if (c[i] * p0[j] + a[i] * p1[j] + b[i] * p2[j] == 0)
     q++;
  printf ("%d\n", q - m + 1);
 }
 return 0;
}
