#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "numbers"

const int LogN = 20, MaxN = 1 << LogN;

int a [MaxN << 1];
int n;

int main (void)
{
 int i, j, k, l, m, sum;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  memset (a, 0, sizeof (a));
  for (m = 0; m < k; m++)
  {
   scanf (" %d", &l);
   if (l == 0)
   {
    scanf (" %d %d", &i, &j);
    i += MaxN;
    j += MaxN + 1;
    sum = 0;
    while (1)
    {
     if (i & 1) sum += a[i], i++;
     if (j & 1) j--, sum += a[j];
     if (i == j) break;
     i >>= 1;
     j >>= 1;
    }
    printf ("%d\n", sum);
   }
   else
   {
    for (l += MaxN; l > 0; l >>= 1)
     a[l]++;
   }
  }
 }
 return 0;
}
