program AConnect;

{$APPTYPE CONSOLE}
{$O-,Q+,R+}

uses
  SysUtils;

var
  N:Longint;
  X, Y:Array[1..200] of Longint;
  Ea, Eb:Array[1..199] of Longint;
  El:Longint;

function Dist(A, B:Longint):Longint;
begin
result := (X[B] - X[A]) * (X[B] - X[A]) + (Y[B] - Y[A]) * (Y[B] - Y[A]); 
end;

procedure IslandTree;
var
  R, D, Di:Array[1..200] of Longint;

  I:Longint;
  Min, Mini:Longint;
begin
fillchar (R, sizeof(R), 0); El := 0;
R[1] := 1;
for I := 1 to N do begin
  D[I] := Dist(1, I);
  Di[I] := 1;
end;

while (true) do begin
  Min := 10000000; Mini := -1;
  for I := 1 to N do
    if (R[I] = 0) and (D[I] < Min) then begin
      Min := D[I];
      Mini := I;
    end;

  if Mini < 1 then break;
  R[Mini] := 1;
  inc (El, 1); Ea[El] := Di[Mini]; Eb[El] := Mini;

  for I := 1 to N do
    if (R[I] = 0) and (Dist(Mini, I) < D[I]) then begin
      D[I] := Dist(Mini, I);
      Di[I] := Mini;
    end;
end;
end;

var
  I:Longint;
  Ans:Real;
begin
assign (input, 'connect.in'); reset (input);
readln (N);
for I := 1 to N do
  readln (X[I], Y[I]);
close (input);

IslandTree;

Ans := 0;
for I := 1 to El do
  Ans := Ans + sqrt(Dist(Ea[I], Eb[I]));

assign (output, 'connect.out'); rewrite (output);
writeln (Ans:0:7);
writeln (El);
for I := 1 to El do
  writeln (Ea[I], ' ', Eb[I]);
close (output);
end.
 